# -*- coding:utf-8 -*-
"""
International prefix rectifing prgramme for Softbank, KK
Programmed by SaltyCat http://d.hatena.ne.jp/SaltyCat/
This program is free software.This program is distributed WITHOUT ANY WARRANTY.You should use it in your own risk. 
jContacts.py
"""
"""
Original program(jContacts.py) was written by Mr. Salty Cat. 
Please see the WEB site (http://d.hatena.ne.jp/SaltyCat/) about 
jContacts.py
I changed it and added some functions for myself. So I change the name
of this Apps. jContacts to jContactsM.
I appreciate to Mr. Salty Cat.

"""
__version__ = '2.01(1)'
__script__  = 'jContactsM'
__author__ = 'Salty Cat & masa'
__web__ = 'http://masaland.cocolog-nifty.com/ \n http://d.hatena.ne.jp/SaltyCat/'
__Copyright__ = ' Copyright (c) 2008-2015 Salty Cat & masa'

import sys,os
sys.setdefaultencoding('utf-8')
if os.path.isdir('E:\\Python\\lib') :
    sys.path.insert(0, 'E:\\Python\\lib')

import contacts
import e32
import appuifw
import telephone
import re
import time

msg_example = 'Name'
msg_nomatch = 'No matching found'
msg_inputword = 'Search Contact Name\n (Partial allowed)'
#Op_identifier = '0046010' # softbank's operator id  and international calling prefix
Op_identifier = '010' # international calling prefix ,'010' or '+' is OK now
Call_prefix = '0037691' #0037-691:mio phone dial
ExitAfterDisc = 0	# option flag for "Exit jContacts after Disconnect"
					# 0:never exit  
					# 1:exit when it enters in Idle state (after calling was started)
					# 2:exit when it enters in Idle state (after call was connected)
					# 3:always exit when it enters in Idle state
Prefix_rectify = 1  # 0: no replace
                    # 1: "+" is replaced with Op_identifier (except "+81")
                    # 2: first "0" is replaced with "+81"
                    # 3: reprace then add call_prefix(mio phone Dial) 
                    # 4: reprace then add call_prefix 
Force_no_prefix_id = 'no call prefix' 
                    #no insert call_prefix when this phrase exist in note field
Conf_file = 'E:\\Data\\masa\\jContactsM.ini'
Log_file  = 'E:\\Data\\masa\\jContactsM.log'
History_log = 1 #1/0 1:write out, Dialled numbers hitory(Log_file)
#--------------
#global variable
Force_no_prefix = ''  # '':undecided yet, 0:No, 1:Yes                     
TempFile = 'D:\\jContacts_sms_temp.html' #temp file '
#

old_title = appuifw.app.title
#appuifw.app.title = u"Contacts Look Up"
#appuifw.app.title = unicode(__script__ + ' ' + __version__)
appuifw.app.title = unicode(__script__ + ' ' + __version__[:4])
body = appuifw.Text()
body.set(unicode(''))
body.color = 0x000000
appuifw.app.body = body

db = contacts.open()	# open contacts database

def get_set_contacts(): # function to extract contacts inputting strings
	tmpKeys = db.keys()
	tmpKeys.sort()
	tmpKeys = tmpKeys[:100]
	c_list = []	# initialise contacts list
	i = 0		# loop counter
	iMax = 3	# max number of loop, ask iMax times input

	ss = str(appuifw.query(unicode(msg_inputword,'utf-8'),'text',unicode(msg_example)))
	if ss == 'None':	#if cancel(right key), select up to 100 contacts
		c_list = [db[x] for x in tmpKeys]
	else:
		c_list = db.find(unicode(ss,'utf-8'))[:100]
	while len(c_list) == 0 and i < (iMax-1) :
		ss = str(appuifw.query(unicode(msg_inputword,'utf-8'),'text',unicode(msg_nomatch)))
		if ss == 'None':	#if cancel(right key), select up to 100 contacts
			c_list = [db[x] for x in tmpKeys]
		else:
			c_list = db.find(unicode(ss,'utf-8'))[:100]
		i = i + 1
	if len(c_list) == 0 : 
		c_list = [db[x] for x in tmpKeys]
	   # after xMax times input failures return  up to 100 contacts list

	return c_list

def get_set_name(c_list): # function to get set of names from extracted contacts
	nm_list = []	# initialise name list
	for c in c_list:
		nm_list.append(c.title)
	return nm_list

def get_set_number(cid): # function to get phone numbers in identified contact id.
	nbr_list = []	# initialise phone number list
	pn = 'phone_number'

	numm = db[cid].find('mobile_number')
	if numm :
		for j in range(len(numm)):
			if numm[j].type != pn and len(numm[j].value) > 1 :
				nbr_list.append(numm[j].value)

	num = db[cid].find(pn)
	if num:
		for j in range(len(num)):
			if len(num[j].value) > 1 :
				nbr_list.append(num[j].value)

	numf = db[cid].find('fax_number')
	if numf:
		for j in range(len(numf)):
			if numf[j].type != pn and len(numf[j].value) > 1 :
				nbr_list.append(numf[j].value)

	numv = db[cid].find('video_number')
	if numv :
		for j in range(len(numv)):
			if numv[j].type != pn and len(numv[j].value) > 1 :
				nbr_list.append(numv[j].value)

	phonenote = db[cid].find('note')
	if phonenote:
		for j in range(len(phonenote)):
			if len(phonenote[j].value) > 1 :
				tmpA = (phonenote[j].value).replace(u"\u2029", u"\n")
				tmpB = [x.strip() for x in tmpA.split(u"\n") if len(x.strip()) > 0]
				if tmpB:
					for x in tmpB:
						nbr_list.append(x)

	if nbr_list == [] : nbr_list = [u'Item has no number']
	return nbr_list

def prefix_rectify(phn_nbr):	# replace international prefix "+" / first "0"
	if   Prefix_rectify == 0: # option = no replace
		return phn_nbr

	elif Prefix_rectify == 1 or (Prefix_rectify == 3 and Force_no_prefix) or \
							(Prefix_rectify == 4 and Force_no_prefix): # in Japan
		if phn_nbr[:3] == '+81':
			return phn_nbr.replace('+81','0',1)	# for domestic Japan
		elif phn_nbr[0] == '+':
			return phn_nbr.replace('+',(Op_identifier + '-'),1) # int'l call from Japan
		else:
			return phn_nbr

	elif Prefix_rectify == 2: # in foreign country
		if phn_nbr[0] == '0':
			return phn_nbr.replace('0','+81',1)	# Call Japan
		else:
			return phn_nbr

	elif Prefix_rectify == 3 and (not Force_no_prefix): # in Japan, use mio_phone dial
		if phn_nbr[:3] == '+81':
			return Call_prefix + '-' + phn_nbr.replace('+81','0',1)	# for domestic Japan
		elif phn_nbr[0] == '+':
			return Call_prefix + '-' + phn_nbr.replace('+','',1) # remove "+"
		elif phn_nbr[0] == '0':
			return Call_prefix + '-' + phn_nbr
		else:
#			return phn_nbr
			return Call_prefix + '-' + phn_nbr


	elif Prefix_rectify == 4 and (not Force_no_prefix) : 
		#multipurpose, G_Call, in foreign country etc.
		if phn_nbr[0] == '0':
			return Call_prefix + '-' + phn_nbr.replace('0','81',1)
		elif phn_nbr[0] == '+':
			return Call_prefix + '-' + phn_nbr.replace('+','',1)
		else:
			return Call_prefix + '-' + phn_nbr
	else:
		return phn_nbr

def write_log(log):
	if History_log and len(log) > 0:
		try:
			f = open(Log_file, 'a')
			f.write(log)
			f.close()
		except:
			pass

def read_log():
	if os.path.isfile(Log_file):
		try:
			f = open(Log_file, 'r')
			return f.read()
			f.close()
		except:
			return 'some error occured'
	else:
		return 'log file not exist'

def remove_file(file, msg):
	if os.path.isfile(file):
		if appuifw.query(unicode(msg), 'query'):
			try:
				os.remove(file)
				appuifw.query(u"File successfully removed !",'query')
			except:
				appuifw.query(u"Some error occured !",'query')
	else:
		appuifw.query(u"File not exist (already removed) !",'query')

def do_dummy():
	pass


def Conf_read():
	global Op_identifier
	global ExitAfterDisc
	global Prefix_rectify
	global Call_prefix
	global Force_no_prefix_id
	global History_log

	try:
		f = open(Conf_file,'r')
		fData = f.read()
		f.close()
	except:
		return

	#split by \n and omit line that contain only (CR/LF)
	lnDatalist = [x for x in fData.split("\n") if len(x) > 1]

	for lnData in lnDatalist:
		lnDatawk = re.sub("[ \t]+"," ",lnData)
		lnDatawk = (re.sub("[\n\r]+","",lnDatawk)).strip()
		confData=lnDatawk.split(" ")
		if len(confData) < 2: continue # no confData[1] error
		if   confData[0].lower() == "op_identifier" : Op_identifier  = confData[1]
		elif confData[0].lower() == "exitafterdisc" : ExitAfterDisc  = int(confData[1])
		elif confData[0].lower() == "prefix_rectify": Prefix_rectify = int(confData[1])
		elif confData[0].lower() == "call_prefix"   : Call_prefix = confData[1]
		elif confData[0].lower() == "force_no_prefix_id":Force_no_prefix_id = confData[1]
		elif confData[0].lower() == "history_log"   : History_log = int(confData[1])

def about():
	msg =   ('App : ' + __script__ + '\n') + \
			('Version : ' + __version__ + '\n') + \
			('(C) ' + __author__ + '\n') + \
			(__web__ )
	appuifw.query(unicode(msg, "utf-8"), "query")


class ChoiceView:
	def __init__(self, Intl_Pfx_RectifyApp):
		self.Intl_Pfx_RectifyApp = Intl_Pfx_RectifyApp
		self.texts = get_set_contacts()
		self.name_list = get_set_name(self.texts)
		self.listbox = appuifw.Listbox(self.name_list, self.handle_select)

	def activate(self):
		appuifw.app.body = self.listbox
		appuifw.app.menu = [(u"Select", self.handle_select),
							(u"Search", self.handle_search),
							(u"View history log", self.view_log),
							(u"About", about),
                            (u"Exit", self.Intl_Pfx_RectifyApp.exit_key_handler)]

	def handle_select(self):
#		n = self.get_name()
#		c_id = self.get_id()
#		appuifw.note(u"Selected: " + n,'info')
		appuifw.app.activate_tab(1)
		self.Intl_Pfx_RectifyApp.handle_tab(1)

	def handle_search(self):
		self.texts = get_set_contacts()
		self.name_list = get_set_name(self.texts)
		self.listbox = appuifw.Listbox(self.name_list, self.handle_select)
		self.activate()

	def get_name(self):
		return self.texts[self.listbox.current()].title

	def get_id(self):
		return self.texts[self.listbox.current()].id

	def view_log(self):
		appuifw.app.activate_tab(3)
		self.Intl_Pfx_RectifyApp.handle_tab(3)

class NumbersView:     
	def __init__(self, Intl_Pfx_RectifyApp):
		self.Intl_Pfx_RectifyApp = Intl_Pfx_RectifyApp
		self.c_id = self.Intl_Pfx_RectifyApp.get_id()
		self.numbers = get_set_number(self.c_id)
		self.numbers_list = appuifw.Listbox(self.numbers, self.handle_select)

	def activate(self):
		global Force_no_prefix
		self.c_id = self.Intl_Pfx_RectifyApp.get_id()
		self.numbers = get_set_number(self.c_id)
		self.numbers_list = appuifw.Listbox(self.numbers, self.handle_select)
		appuifw.app.body = self.numbers_list
		Force_no_prefix = ''
		if Prefix_rectify > 2: #option 3,4
			appuifw.app.menu = [(u"Select", self.handle_select),
								(u"Select with   call_prefix", self.handle_select_cp),
								(u"Select without call_prefix", self.handle_select_nocp),
								(u"Start sms", self.start_sms),
                                (u"Exit", self.Intl_Pfx_RectifyApp.exit_key_handler)]

			tmpA = re.compile(unicode(Force_no_prefix_id,'utf-8'), re.I)
			for nbr in self.numbers:
				nbr = re.sub(u"[ \t]+",u" ", nbr)
				if tmpA.search(nbr) != None:
					Force_no_prefix = 1
					break
		else:
			appuifw.app.menu = [(u"Select", self.handle_select),
								(u"Start sms", self.start_sms),
                                (u"Exit", self.Intl_Pfx_RectifyApp.exit_key_handler)]

	def handle_select(self):
#		nbr = self.get_number()
#		appuifw.note(u"Selected: " + nbr,'info')
		appuifw.app.activate_tab(2)
		self.Intl_Pfx_RectifyApp.handle_tab(2)

	def handle_select_cp(self):
		global Force_no_prefix
		Force_no_prefix = 0
		appuifw.app.activate_tab(2)
		self.Intl_Pfx_RectifyApp.handle_tab(2)

	def handle_select_nocp(self):
		global Force_no_prefix
		Force_no_prefix = 1
		appuifw.app.activate_tab(2)
		self.Intl_Pfx_RectifyApp.handle_tab(2)

	def get_number(self):
		return self.numbers[self.numbers_list.current()]

	def get_int_number(self):
		return prefix_rectify(self.numbers[self.numbers_list.current()])

	def start_sms(self):
		global Force_no_prefix
		if Prefix_rectify > 2: #option 3,4
			Force_no_prefix = True #don't add call_prefix when send sms
		nbr = self.get_number()
		if nbr.find('Item')  != -1 : #no number
			appuifw.query(u'Selected item has no number !!\n Y/N back to list', 'query')
		elif re.search('[^0-9pPwW+*#\-]', nbr) != None: #not number (note item)
			appuifw.query(u'Selected item is not number !!\n Y/N back to list', 'query')
		else:
			nbr = self.get_int_number()
#			nbr = re.sub('-', '', nbr) #remove '-'
			try:
				F = open(TempFile, 'w')

				F.write('<html><head>\n')
				F.write('<META http-equiv="Content-Type" content="text/html; charset=UTF-8">')
				F.write('<meta http-equiv="Refresh" content="0;URL=sms:%s">' % nbr)
				F.write('<title>text message</title>')
				F.write('</head><body>')
				F.write('sms作成画面を起動しました。<br>')
				F.write('この画面は閉じて下さって結構です。<br>')
				F.write('</body></html>')
				F.close()
				appuifw.Content_handler().open(TempFile)
			except:
				appuifw.query(u'Start sms error !!\n Y/N back to list', 'query')

class SendView:
	def __init__(self, Intl_Pfx_RectifyApp):
		self.Intl_Pfx_RectifyApp = Intl_Pfx_RectifyApp
		self.log_text = appuifw.Text()
		self.log_text.color = 0x000000
		self.log_contents = u""

	def activate(self):
		global Force_no_prefix
		self.log_text.set(self.log_contents)
		appuifw.app.body = self.log_text
#		self.log_text.focus = False
		appuifw.app.menu = [(u"Exit", self.Intl_Pfx_RectifyApp.exit_key_handler)]

		nbr = self.Intl_Pfx_RectifyApp.get_number()
		if Prefix_rectify > 2 and Force_no_prefix == '' : #option 3,4
			if len(nbr) == 3: #ex 119/110
				Force_no_prefix = 1
			elif nbr[:4] == '0120' or nbr[:4] == '0800' or nbr[:4] == '0570':
				#free dial
				Force_no_prefix = 1
#			elif nbr[0] != '0' and  nbr[0] != '+':
#				Force_no_prefix = 1

		if Force_no_prefix == 1: Force_no_prefix = True
		else:                    Force_no_prefix = False

		if nbr.find('Item')  != -1 : #no number
			appuifw.query(u'Selected item has no number !!\n Y/N back to list', 'query')
		elif re.search('[^0-9pPwW+*#\-]', nbr) != None: #not number (note item)
			appuifw.query(u'Selected item is not number !!\n Y/N back to list', 'query')
		else:
			nbr = self.Intl_Pfx_RectifyApp.get_int_number()
			if appuifw.query(unicode("calling to " + nbr + " ?"), 'query'):
				name = self.Intl_Pfx_RectifyApp.get_name()
				dialtime = time.strftime("%Y-%m-%d %H:%M", time.localtime())
				t = "%s\n    %s\n    %s\n" % (name[:13], nbr, dialtime)
				self.log_text.add(t)
				nbr = re.sub('-', '', nbr) #remove '-'
				try:telephone.hang_up()
				except RuntimeError:pass
				e32.ao_sleep(1)
				self.log_contents = self.log_contents + t
				telephone.dial(nbr)
				self.status = 'None'
				telephone.call_state(self.check_state)

	def check_state(self,(state, number)):
		if state == telephone.EStatusConnected: self.status = 'EStatusConn'
		if state == telephone.EStatusDisconnecting and self.status == 'None':
			self.status = 'EStatusDisc'
		if state == telephone.EStatusIdle:	#Disconnect complete
			if   ExitAfterDisc == 3:
				self.Intl_Pfx_RectifyApp.exit_key_handler() #Exit
			elif ExitAfterDisc == 2 and self.status == 'EStatusConn':
				self.Intl_Pfx_RectifyApp.exit_key_handler() #Exit
			elif ExitAfterDisc == 1 and self.status != 'None':
				self.Intl_Pfx_RectifyApp.exit_key_handler() #Exit

class HistlogView:
	def __init__(self, Intl_Pfx_RectifyApp):
		self.Intl_Pfx_RectifyApp = Intl_Pfx_RectifyApp
		self.log_text = appuifw.Text()
		self.log_text.color = 0x000000
		self.log_text.font = 'dense'
		self.log_contents = u""

	def activate(self):
		self.log_contents = unicode(read_log(), 'utf-8')
		self.log_text.set(self.log_contents)
		appuifw.app.body = self.log_text
#		self.log_text.focus = True
		appuifw.app.menu = [(u'back to name_view', self.back2list),
							(u"Delete log file", self.del_log_file),
                            (u"Exit", self.Intl_Pfx_RectifyApp.exit_key_handler)]

	def back2list(self):
		appuifw.app.activate_tab(0)
		self.Intl_Pfx_RectifyApp.handle_tab(0)

	def del_log_file(self):
		remove_file(Log_file, msg='Delete log file ?')
		self.activate()

class Intl_Pfx_RectifyApp:
	def __init__(self):
		self.lock = e32.Ao_lock()
		appuifw.app.exit_key_handler = do_dummy
		self.c_view = ChoiceView(self)
		self.n_view = NumbersView(self)
		self.s_view = SendView(self)
		self.h_view = HistlogView(self)
		self.views = [self.c_view, self.n_view, self.s_view, self.h_view]
		appuifw.app.set_tabs([u"Name", u"Number", u"Call", u"Log"],                                       self.handle_tab)

	def run(self):
		self.handle_tab(0)
		self.lock.wait()
		self.close_ap()

	def get_name(self):
		return self.c_view.get_name()

	def get_id(self):
		return self.c_view.get_id()

	def get_number(self):
		return self.n_view.get_number()

	def get_int_number(self):
		return self.n_view.get_int_number()

	def handle_tab(self, index):
		self.views[index].activate()

	def exit_key_handler(self):
		self.lock.signal()

	def close_ap(self):
		log = self.s_view.log_contents
		write_log(log)
		appuifw.app.exit_key_handler = None
		appuifw.app.set_tabs([u"Back to normal"], lambda x: None)
		del self.s_view
		del self.c_view
		del self.n_view
		del self.h_view

Conf_read()
myApp = Intl_Pfx_RectifyApp()
myApp.run()

appuifw.app.title = old_title
del myApp

appuifw.menu = None
#appuifw.app.set_exit()
#sys.exit()

